/*
 * DPharp HART Device Description Header File
 *
 *	Yokogawa Electric Corporation
 *
 *	Change notes: (File name, Date, Name, Description)
 * =========================================================================
 *  dpharp_cmn_macro.h	2010-10-19	Y. Kawasaki		New
 */

#define _EASY_UNITS ";kPa;MPa;mbar;bar;psi;psia;mmH2O;mmHg;mmHgA;mmAq;mmWG;Torr;inH2O;inHg;inHgA;ftH2O;gf/cm2;kgf/cm2;kg/cm2G;kg/cm2A;atm;kg/h;t/h;m3/h;m3/min;l/h;l/min;kl/h;kl/min;Nl/h;Nl/min;Nm3/h;Nm3/min;ACFH;ACFM;SCFH;SCFM;GPH;GPM;m;mm;in;ft;kg/m3;g/cm3"
#define _EASY_UNIT_MAX 46

#define _SI_EASY_UNITS ";kPa;MPa;mbar;bar;atm;kg/h;t/h;m3/h;m3/min;l/h;l/min;kl/h;kl/min;Nl/h;Nl/min;Nm3/h;Nm3/min;m;mm;kg/m3;g/cm3"
#define _SI_EASY_UNIT_MAX 22

#define _TRIM_MODES "Off;Auto, Lower Pt;Auto, Upper Pt;Manual, Lower Pt;Manual, Upper Pt"

#define MAXIMUM_SELFTEST_TIMES  3
#define DEVICE_BUSY   32
#define ERR_LOG_EXIT  4

#define all_xmtr_error_chk_and_disp() \
{ \
	xmtr_error_chk_and_disp_part_1(); \
	xmtr_error_chk_and_disp_part_2(); \
}

#define all_xmtr_warn_chk_and_disp() \
{ \
	xmtr_warn_chk_and_disp_part_1(); \
	xmtr_warn_chk_and_disp_part_2(); \
	xmtr_warn_chk_and_disp_part_3(); \
	xmtr_warn_chk_and_disp_part_4(); \
	xmtr_warn_chk_and_disp_part_5(); \
}

#define all_xmtr_status_chk_and_disp() \
{ \
	all_xmtr_error_chk_and_disp(); \
	all_xmtr_warn_chk_and_disp(); \
}

#define ENGR_DISP_FMT SELECT( engr_disp_point ) {\
	CASE   0: 	".0f";\
	CASE   1: 	".1f";\
	CASE   2: 	".2f";\
	CASE   3: 	".3f";\
	CASE   4: 	".4f";\
	CASE   5: 	".5f";\
}\

#define ignore_rsp_cod_and_dev_sts() \
{ \
	IGNORE_ALL_RESPONSE_CODES(); \
	IGNORE_ALL_DEVICE_STATUS(); \
	XMTR_IGNORE_ALL_DEVICE_STATUS(); \
	XMTR_IGNORE_ALL_RESPONSE_CODES(); \
}

#define _DIAG_MODE		"Stop;Calculation;Reference"
#define _DIAG_MODE_MAX	2

#define TEMP_UNIT_CODES	\
		{ 32, [degC]}, 	\
		{ 33, [degF]}, 	\
		{ 35, [Kelvin]}

#define SI_TEMP_UNIT_CODES	\
		{ 32, [degC]}, 	\
		{ 35, [Kelvin]}


#define	EJX_FUNC_CTRL_MASKBIT_SIG	(0x01)	//-- 0bit ړ_M@
#define	EJX_FUNC_CTRL_MASKBIT_ADV	(0x04)	//-- 2bit AhoXff@
/* TRUE : @\L / FALSE : @\ */
#if _MODELTYPE_EJA
#define VALID_EJX_FUNC_CTRL(EJX_FUNC_CTRL_MASKBIT)  \
	IF(ejx_func_ctrl & EJX_FUNC_CTRL_MASKBIT){\
		FALSE;\
	} ELSE {\
		TRUE;\
	}
#else
#define VALID_EJX_FUNC_CTRL(EJX_FUNC_CTRL_MASKBIT)	TRUE;
#endif
