/*
 * DPharp HART Device Description Header File
 *
 *	Yokogawa Electric Corporation
 *
 *	Change notes: (File name, Date, Name, Description)
 * =========================================================================
 *  dpharp_h7_macro.h	2010-10-19	Y. Kawasaki		New
 */


#define xmtr_status_chk_and_disp(byt_no, bit_pt) \
{ \
	if ( xmtr_status[byt_no] & bit_pt )  display_xmtr_status(device_specific_status_##byt_no, bit_pt); \
}


#define all_xmtr_diag_chk_and_disp() \
{ \
	xmtr_warn_chk_and_disp_part_6(); \
	xmtr_warn_chk_and_disp_part_7(); \
	xmtr_warn_chk_and_disp_part_8(); \
}


#define xmtr_error_chk_and_disp_part_1() \
{ \
	xmtr_status_chk_and_disp( 0, 0x80 ); \
	xmtr_status_chk_and_disp( 0, 0x20 ); \
	xmtr_status_chk_and_disp( 0, 0x10 ); \
	xmtr_status_chk_and_disp( 0, 0x04 ); \
	xmtr_status_chk_and_disp( 0, 0x02 ); \
}

#define xmtr_error_chk_and_disp_part_2() \
{ \
	xmtr_status_chk_and_disp( 1, 0x80 ); \
	xmtr_status_chk_and_disp( 1, 0x04 ); \
	xmtr_status_chk_and_disp( 2, 0x08 ); \
}

#define xmtr_warn_chk_and_disp_part_1() \
{ \
	xmtr_status_chk_and_disp( 2, 0x80 ); \
	xmtr_status_chk_and_disp( 2, 0x40 ); \
	xmtr_status_chk_and_disp( 2, 0x20 ); \
	xmtr_status_chk_and_disp( 2, 0x10 ); \
}

#define xmtr_warn_chk_and_disp_part_2() \
{ \
	xmtr_status_chk_and_disp( 3, 0x80 ); \
	xmtr_status_chk_and_disp( 3, 0x40 ); \
}

#define xmtr_warn_chk_and_disp_part_3() \
{ \
	xmtr_status_chk_and_disp( 4, 0x80 ); \
	xmtr_status_chk_and_disp( 4, 0x40 ); \
	xmtr_status_chk_and_disp( 4, 0x20 ); \
	xmtr_status_chk_and_disp( 4, 0x10 ); \
	xmtr_status_chk_and_disp( 4, 0x08 ); \
	xmtr_status_chk_and_disp( 4, 0x04 ); \
}

#define xmtr_warn_chk_and_disp_part_4() \
{ \
	xmtr_status_chk_and_disp( 5, 0x80 ); \
	xmtr_status_chk_and_disp( 5, 0x40 ); \
	xmtr_status_chk_and_disp( 5, 0x20 ); \
	xmtr_status_chk_and_disp( 5, 0x10 ); \
	xmtr_status_chk_and_disp( 5, 0x08 ); \
	xmtr_status_chk_and_disp( 5, 0x04 ); \
	xmtr_status_chk_and_disp( 5, 0x02 ); \
	xmtr_status_chk_and_disp( 5, 0x01 ); \
}

#define xmtr_warn_chk_and_disp_part_5() \
{ \
	xmtr_status_chk_and_disp( 14, 0x80 ); \
	xmtr_status_chk_and_disp( 14, 0x40 ); \
	xmtr_status_chk_and_disp( 14, 0x08 ); \
}

#define xmtr_warn_chk_and_disp_part_6() \
{ \
	xmtr_status_chk_and_disp( 15, 0x40 ); \
	xmtr_status_chk_and_disp( 15, 0x20 ); \
	xmtr_status_chk_and_disp( 15, 0x10 ); \
	xmtr_status_chk_and_disp( 15, 0x08 ); \
	xmtr_status_chk_and_disp( 15, 0x04 ); \
	xmtr_status_chk_and_disp( 15, 0x02 ); \
	xmtr_status_chk_and_disp( 15, 0x01 ); \
}

#define xmtr_warn_chk_and_disp_part_7() \
{ \
	xmtr_status_chk_and_disp( 16, 0x80 ); \
	xmtr_status_chk_and_disp( 16, 0x40 ); \
	xmtr_status_chk_and_disp( 16, 0x20 ); \
	xmtr_status_chk_and_disp( 16, 0x10 ); \
	xmtr_status_chk_and_disp( 16, 0x08 ); \
	xmtr_status_chk_and_disp( 16, 0x04 ); \
}

#define xmtr_warn_chk_and_disp_part_8() \
{ \
	xmtr_status_chk_and_disp( 17, 0x80 ); \
	xmtr_status_chk_and_disp( 17, 0x40 ); \
	xmtr_status_chk_and_disp( 17, 0x20 ); \
}

#define ENGINEER_UNIT_CODES	\
		{  0, ""},	\
		{  1, [kPA]},	\
		{  2, [mega_pascals]},	\
		{  3, [mbar]},	\
		{  4, [bar]},	\
		{  5, [psi]},	\
		{  6, "psia"},	\
		{  7, [mmH2O]},	\
		{  8, [mmHg]},	\
		{  9, "mmHgA"},	\
		{ 10, "mmAq"},	\
		{ 11, "mmWG"},	\
		{ 12, "Torr"},	\
		{ 13, [InH2O]},	\
		{ 14, [InHg]},	\
		{ 15, "inHgA"},	\
		{ 16, [FtH2O]},	\
		{ 17, "gf/cm2"},	\
		{ 18, "kgf/cm2"},	\
		{ 19, "kg/cm2G"},	\
		{ 20, "kg/cm2A"},	\
		{ 21, [ATM]},	\
		{ 22, [kg_hr]},	\
		{ 23, "t/h"},	\
		{ 24, "m3/h"},	\
		{ 25, "m3/min"},	\
		{ 26, "l/h"},	\
		{ 27, "l/min"},	\
		{ 28, "kl/h"},	\
		{ 29, "kl/min"},	\
		{ 30, "Nl/h"},	\
		{ 31, "Nl/min"},	\
		{ 32, "Nm3/h"},	\
		{ 33, "Nm3/min"},	\
		{ 34, "ACFH"},	\
		{ 35, "ACFM"},	\
		{ 36, "SCFH"},	\
		{ 37, "SCFM"},	\
		{ 38, "GPH"},	\
		{ 39, "GPM"},	\
		{ 40, [meter]},	\
		{ 41, [mm]},	\
		{ 42, [in]},	\
		{ 43, [ft]},	\
		{ 44, "kg/m3"},	\
		{ 45, "g/cm3"}

#define SI_ENGINEER_UNIT_CODES	\
		{  0, ""},	\
		{  1, [kPA]},	\
		{  2, [mega_pascals]},	\
		{  3, [mbar]},	\
		{  4, [bar]},	\
		{ 21, [ATM]},	\
		{ 22, [kg_hr]},	\
		{ 23, "t/h"},	\
		{ 24, "m3/h"},	\
		{ 25, "m3/min"},	\
		{ 26, "l/h"},	\
		{ 27, "l/min"},	\
		{ 28, "kl/h"},	\
		{ 29, "kl/min"},	\
		{ 30, "Nl/h"},	\
		{ 31, "Nl/min"},	\
		{ 32, "Nm3/h"},	\
		{ 33, "Nm3/min"},	\
		{ 40, [meter]},	\
		{ 41, [mm]},	\
		{ 44, "kg/m3"},	\
		{ 45, "g/cm3"}

#define ENUM_CURRENT_UNIT_CODES	\
		{ 39,	[mA],	[milliamperes_help]	}
#define ENUM_PERCENT_UNIT_CODES	\
		{ 57,	[Percent],	[percent_help]	}

#define FLAG_ASSIGNMENT(N) { N, flag_assignment(N) }

#define DEVICE_VARIABLE_CODE_PV				0
#define DEVICE_VARIABLE_CODE_SV				1
#define DEVICE_VARIABLE_CODE_TV				2
#define DEVICE_VARIABLE_CODE_PER_RANGE		244
#define DEVICE_VARIABLE_CODE_LOOP_CUR		245
#define DEVICE_VARIABLE_CODE_NOT_USED		250

#define DEF_CMD9_PRM_DEVICE_VARIABLES(dev_var_code)	\
		deviceVariables[dev_var_code].CLASSIFICATION,	\
		deviceVariables[dev_var_code].DIGITAL_UNITS<0xFF>,	\
		deviceVariables[dev_var_code].DIGITAL_VALUE,	\
		deviceVariables[dev_var_code].DATA_QUALITY <0xC0>,	\
		deviceVariables[dev_var_code].LIMIT_STATUS <0x30>,	\
		deviceVariables[dev_var_code].DEVICE_FAMILY_STATUS <0x0F>

#define LABEL_BURST_DEVICE_VARIABLE_CLASS	"Burst Trigger Class";
#define ENUM_BURST_DEVICE_VARIABLE_CLASS	\
		DEVICE_VARIABLE_CLASSIFICATION_CODE(0),  \
		DEVICE_VARIABLE_CLASSIFICATION_CODE(64), \
		DEVICE_VARIABLE_CLASSIFICATION_CODE(65), \
		DEVICE_VARIABLE_CLASSIFICATION_CODE(84)

#define BIT_ENUM_ITEM_STATUS_GROUP_1	\
		{0x80, "P sensor error", 	HARDWARE}, 	\
		{0x20, "CT sensor error", 	HARDWARE}, 	\
		{0x10, "Cap EEPROM error", 	HARDWARE}, 	\
		{0x04, "AT sensor error", 	HARDWARE}, 	\
		{0x02, "Amp EEPROM error", 	HARDWARE}

#define BIT_ENUM_ITEM_STATUS_GROUP_2	\
		{0x80, "CPU board error", 	HARDWARE}, 	\
		{0x04, "No device ID", 		HARDWARE}

#define BIT_ENUM_ITEM_STATUS_GROUP_3	\
		{0x80, "P outside limit", 		PROCESS},	\
		{0x40, "SP outside limit", 		PROCESS},	\
		{0x20, "CT outside limit", 		PROCESS},	\
		{0x10, "AT outside limit", 		PROCESS}

#define BIT_ENUM_ITEM_STATUS_GROUP_4	\
		{0x80, "P over range", 		PROCESS}, 	\
		{0x40, "SP over range", 	PROCESS}

#define BIT_ENUM_ITEM_STATUS_GROUP_5	\
		{0x80, "P high alarm", 		PROCESS}, 	\
		{0x40, "P low alarm", 		PROCESS}, 	\
		{0x20, "SP high alarm", 	PROCESS}, 	\
		{0x10, "SP low alarm", 		PROCESS}, 	\
		{0x08, "CT high alarm", 	PROCESS}, 	\
		{0x04, "CT low alarm", 		PROCESS}

#define BIT_ENUM_ITEM_STATUS_GROUP_6	\
		{0x80, "Illegal P LRV", 	DATA}, 	\
		{0x40, "Illegal P URV", 	DATA}, 	\
		{0x20, "Illegal P SPAN", 	DATA}, 	\
		{0x10, "P SPAN trim err", 	DATA}, 	\
		{0x08, "P ZERO trim err", 	DATA}, 	\
		{0x04, "Illegal SP LRV", 	DATA}, 	\
		{0x02, "Illegal SP URV", 	DATA}, 	\
		{0x01, "Illegal SP SPAN", 	DATA}

#define BIT_ENUM_ITEM_STATUS_GROUP_7	\
		{0x80, "SP SPAN trim err", 	DATA}, 	\
		{0x40, "SP ZERO trim err", 	DATA}, 	\
		{0x08, "SC config error", 	DATA}

#define BIT_ENUM_ITEM_STATUS_GROUP_8	\
		{0x40, "FT high alarm", 	PROCESS},	\
		{0x20, "FT low alarm", 		PROCESS},	\
		{0x10, "ILBD over range", 	PROCESS},	\
		{0x08, "Invalid Ref DP", 	PROCESS},	\
		{0x04, "Invalid Ref SPL", 	PROCESS},	\
		{0x02, "Invalid Ref SPH", 	PROCESS},	\
		{0x01, "Invalid Ref F", 	PROCESS}

#define BIT_ENUM_ITEM_STATUS_GROUP_9	\
		{0x80, "B Blocking",			PROCESS},	\
		{0x40, "H Side Blocking",		PROCESS},	\
		{0x20, "L Side Blocking",		PROCESS},	\
		{0x10, "Large Fluct H",			PROCESS},	\
		{0x08, "Large Fluct L",			PROCESS},	\
		{0x04, "A Blocking",			PROCESS}

#define BIT_ENUM_ITEM_STATUS_GROUP_10	\
		{0x80, "P.Simulate Mode",		MODE},	\
		{0x40, "SP.Simulate Mode",		MODE},	\
		{0x20, "T.Simulate Mode",		MODE}

/*		2021-02-09	
#if _FORDTM
#define ENUM_BURST_UPDATE_PERIOD \
			{	16000,		"0.5 s"		},\
			{	32000,		"1 s"		},\
			{	64000,		"2 s"		},\
			{	128000,		"4 s"		},\
			{	256000,		"8 s"		},\
			{	512000,		"16 s"		},\
			{	1024000,	"32 s"		},\
			{	1920000,	"1 min"		},\
			{	9600000,	"5 min"		},\
			{	19200000,	"10 min"		},\
			{	28800000,	"15 min"		},\
			{	57600000,	"30 min"		},\
			{	86400000,	"45 min"		},\
			{	115200000,	"60 min"		}

#define ENUM_EVENT_NOTIFY_RETRY_TIME	ENUM_BURST_UPDATE_PERIOD
#define ENUM_EVENT_MAX_UPDATE_TIME		ENUM_BURST_UPDATE_PERIOD
#define ENUM_EVENT_DEBOUNCE_TIME	\
		{	0,		"Off"		},\
		ENUM_BURST_UPDATE_PERIOD
#endif
*/
#define ENUM_VALUE_UPDATE_TIME_PERIOD	\
		{	0,			"0 ms"		},	\
		{	1440,		"45 ms"		},	\
		{	11520,		"360 ms"		},	\
		{	32000,		"1 s"			}

#define DEV_VAR_LABEL_DATA_QUALITY		"Data Quality"
#define DEV_VAR_LABEL_LIMIT_STATUS		"Limit Status"

//		2021-02-09	#if __TOKVER__ >= 800
#define BURST_MSG_COLLECTION(burst_no)		burst_messages[burst_no]
#define EVENT_COLLECTION(event_no)		compat_events[event_no]
//	2021-02-04	#define EVENT_COLLECTION(event_no)			events[event_no]
//		2021-02-09	#endif



/*	VARIABLE LABEL String Define	*/
#define	DEF_LABEL_SP_MIN_SPAN		"SP Min span"
#define	DEF_LABEL_BAR_INDICATOR		"Bar indicator"
#define	DEF_LABEL_FLG_TEMP_COEF		"Flg Temp Coef"
#define	DEF_LABEL_FLG_TEMP_HI_ALERT	"Flg Temp Hi Alert Val"
#define	DEF_LABEL_FLG_TEMP_LO_ALERT	"Flg Temp Lo Alert Val"

/*	VARIABLE HELP String Define	*/
#define	DEF_HELP_FLG_TEMP_COEF		"Flg Temp Coef."
#define	DEF_HELP_FLG_TEMP_HI_ALERT	"Flg Temp Hi Alert Val."
#define	DEF_HELP_FLG_TEMP_LO_ALERT	"Flg Temp Lo Alert Val."


/* Pressure unit code number */
#define	PRESS_UNIT_CODE_FTH2O_4DEGC		177
#define	PRESS_UNIT_CODE_HPA				174

//		2021-02-09	
//		2021-02-09	#if _FORDTM
//		2021-02-09	#define BURST_VAR_CODE(burst_no, var_no)	device_variable_codes_for_bursts[burst_no][var_no]
//		2021-02-09	#endif
